;-------------------------------------------------
; deklaracja wyjciowego formatu pliku DLL
;-------------------------------------------------
format PE GUI 4.0 DLL

; nazwa funkcji wejciowej naszej biblioteki
entry DllEntryPoint

; plik nagwkowy z definicjami
; i staymi dla Windows
include '%fasm%\include\win32a.inc'

;-------------------------------------------------
; sekcja z niezainicjalizowanymi wartociami
;-------------------------------------------------
section '.bss' readable writeable

; uchwyt HMODULE oryginalnej biblioteki
	hLibOrg		dd ?

;-------------------------------------------------
; sekcja z zainicjalizowanymi danymi
;-------------------------------------------------
section '.data' data readable writeable

; nazwa oryginalnej biblioteki
	szDllOrg	db 'BlackBox_org.dll',0

;-------------------------------------------------
; sekcja z kodem naszej biblioteki
;-------------------------------------------------
section '.text' code readable executable

;-------------------------------------------------
; punkt wejciowy biblioteki dynamicznej (DllMain)
;-------------------------------------------------
proc DllEntryPoint hinstDLL, fdwReason, lpvReserved

	mov	eax,[fdwReason]

; komunikat wysyany po zaadowaniu biblioteki DLL
	cmp	eax,DLL_PROCESS_ATTACH
	je	_dll_attach

	jmp	_dll_exit

; biblioteka zostaa wanie zaadowana
_dll_attach:

; pobierz uchwyt oryginalnej biblioteki, moe si
; on przyda gdybymy chcieli wywoa oryginalne
; funkcje
	push	szDllOrg
	call	[GetModuleHandleA]
	mov	[hLibOrg],eax

; zwrc 1 co oznacza, e powioda si 
; inicjalizacja naszej biblioteki
	mov	eax,1

_dll_exit:

	ret

; wywoaj jakkolwiek funkcj z oryginalnej
; biblioteki BlackBox_org.dll, bez tego FASM
; usuwa referencje do tej biblioteki i nie
; zostanie ona automatycznie zaadowana
	call	dummy
endp

;-------------------------------------------------
; nasza implementacja funkcji Sumuj z poprawionym
; kodem, odpornym na dzielenie przez zero
;-------------------------------------------------
proc Podziel Liczba1, Liczba2, Wynik

; dzielnik, sprawd czy jest to zero, jeli tak to
; wyjd z kodem bdu z funkcji
	mov	ecx,[Liczba2]
	test	ecx,ecx
	je	PodzielBlad

; zaaduj pierwsz liczb (rejestr EDX rozszerz
; o znak wartoci int Liczba1)
	mov	eax,[Liczba1]
	cdq

; wykonaj dzielenie EDX:EAX / ECX, dzielenie
; wykonuje si na parze rejestrw EDX:EAX, ktre
; traktowane s jako liczba 64 bitowa, wynik
; dzielenia znajdzie si w rejestrze EAX, reszta
; z dzielenia zostanie zapisana w rejestrze EDX
	idiv	ecx

; czy podany jest wskanik, gdzie ma by zapisany
; wynik jeli brak wskanika, wyjd z kodem bdu
	mov	edx,[Wynik]
	test	edx,edx
	je	PodzielBlad

; zapisz wynik dzielenia pod wskazany adres
	mov	[edx],eax

; wyjd z kodem TRUE (1)
	mov	eax,1

	jmp	PodzielWyjdz

; bd dzielenia, zwr warto FALSE (0)
PodzielBlad:

	sub	eax,eax

PodzielWyjdz:

; wyjd z funkcji dzielenia z ustawionym
; kodem bdu w EAX
	ret
endp

;-------------------------------------------------
; sekcja z funkcjami wykorzystywanymi przez nasz
; bibliotek
;-------------------------------------------------
section '.idata' import data readable writeable

; lista bibliotek, ktrych funkcji uywamy
library kernel,'KERNEL32.DLL',\
	blackbox, 'BlackBox_org.dll'

; lista funkcji z biblioteki KERNEL32.dll
import	kernel,\
	GetModuleHandleA, 'GetModuleHandleA'

; deklarujemy uycie oryginalnej biblioteki, co
; sprawi, e zostanie ona automatycznie
; zaadowana
import	blackbox,\
	dummy, 'Podziel'

;-------------------------------------------------
; sekcja z funkcjami eksportowanymi przez nasz
; bibliotek, musimy tu zadeklarowa wszystkie
; funkcje, ktre znajduj si w oryginalnej
; bibliotece
;-------------------------------------------------
section '.edata' export data readable

; lista eksportowanych funkcji i ich wskaniki
export	'BlackBox.dll',\
	Sumuj, 'Sumuj',\
	Podziel, 'Podziel'

; nazwa przekazywanej funkcji, najpierw deklaruje
; si nazw biblioteki, do ktrej ma nastpi
; przekierowanie, a po kropce deklaruje si nazw
; docelowej funkcji
	Sumuj db 'BlackBox_org.Sumuj',0

;-------------------------------------------------
; sekcja relokacji
;-------------------------------------------------
section '.reloc' fixups data discardable
